/* a simple CGI parser (not optimized) */

CGI := Object clone do(

    parse := method(
      q := System getenv("QUERY_STRING")
      contentLength := System getenv("CONTENT_LENGTH")
      
      if (contentLength, 
	    post := File clone standardInput readStringOfLength(contentLength asNumber)
	    q = if (q != "", q .. "&" .. post, post)
      )
      if(q == Nil, q = "")
      //write("<PRE> q := ", q, "</PRE>\n")
      return self parseString(q)
    )

    parseString := method(q, 
      q = q replace("+", " ")

      form := Map clone
      q split("&") foreach(i, v, 
	kv := v split("=")
	if(kv count == 2) then (
	  k := kv at(0)
	  v := decodeUrlParam(kv at(1))

	  if (form hasKey(k), 
	    vallist := List clone

	    // this already exists, so we want to take the value of k, 
	    // and make a list of the values, 
	    // remove the original k/v then add k/v as list back.

	    if (form at(k) type == "List", 
		    //it's a list already, so just add the value at the end
		    vallist = form at(k)
		    vallist add(v)
	    ) else (
		    vallist add(form at(k))  
		    vallist add(v)
	    )

	    form removeAt(k)
	    form atPut(k, vallist)
	  )  else (
	    form atPut(k, v)
	  )
	) else ( 
	  kv := kv at(0) split(",")
	  form atPut("imageMapX", kv at(0))
	  form atPut("imageMapY", kv at(1))
	)
      )
      return form
    )

    urlCodes := Map clone

    setup := method(
      for (i, 0, 255,
	code := i asString toBase(16) upper
	if (code length == 1, code = "0" .. code)
	/*write(i, " := ", i asCharacter, " := ", "%" .. code, "<BR>")*/
	self urlCodes atPut(i asCharacter, "%" .. code) 
      )
    )

    setup

    urlPlains := Map clone do(
	    atPut(" ", "+")
	    atPut("*", "*")
	    atPut("-", "-")
	    atPut(".", ".")
	    for (i, 48, 57, atPut(i asCharacter, i asCharacter))
	    for (i, 65, 90, atPut(i asCharacter, i asCharacter))
	    atPut("_", "_")
	    for (i, 97, 122, atPut(i asCharacter, i asCharacter))
    )

    encodeUrlParam := method(sIn,
	    sOut := Buffer clone
	    sIn foreach(i, v,
		    c := v asCharacter
		    p := urlPlains at(c)
		    sOut append(if(p, p, urlCodes at(c)))
	    )
	    return sOut asString
    )

    /*
    encodeUrlParam := method(s,  
      urlCodes foreach(k, v, s = s replace(k, v))
      return s
    )
    */

    decodeUrlParam := method(s,
      urlCodes foreach(k, v, s = s replace(v, k))
      return s
    )

)
